<template>
    <div class="price">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">价格管理</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getPriceList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    ref="multipleTable"
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="id" label="序号" width="80"></el-table-column>
                    <el-table-column prop="productName" label="产品名称" width="180"></el-table-column>
                    <el-table-column prop="specificModel" label="规格型号" width="180"></el-table-column>
                    <el-table-column prop="category" label="所属类别"></el-table-column>
                    <el-table-column prop="price" label="价格(元)"></el-table-column>
                    <el-table-column prop="operation" label="操作"></el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form ref="addPrice" :model="formData" :rules="rules" label-width="140px">
                        <el-form-item label="产品名称">
                            <el-input v-model="formData.productName"></el-input>
                        </el-form-item>

                        <el-form-item label="规格型号">
                            <el-input v-model="formData.specificModel"></el-input>
                        </el-form-item>

                        <el-form-item label="所属类别">
                            <el-input v-model="formData.category"></el-input>
                        </el-form-item>

                        <el-form-item label="价格(元)">
                            <el-input v-model="formData.price"></el-input>
                        </el-form-item>

                        <el-form-item label="操作">
                            <el-input v-model="formData.operation"></el-input>
                        </el-form-item>

                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addPrice')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqPriceList,
    reqAddPrice,
    reqUpdatePrice,
    reqDelPrice
} from "@/api/sellManagement.js";

const pageSize = 10;
const rules = {};

export default {
    name: "price",
    data() {
        return {
            search: "",
            page: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                productName: "大羊排",
                specificModel: "2500g/袋",
                category: "成品",
                price: "198",
                operation: 1
            },
            isAdd: false,
            rules
        };
    },
    created() {
        // 出仓管理列表
        this.getPriceList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    if (this.isAdd) {
                        reqAddPrice(this.formData)
                            .then(res => {
                                // 出仓管理列表
                                this.getPriceList();
                                this.$message.success("添加成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("添加失败！");
                            });
                    } else {
                        reqUpdatePrice(this.formData)
                            .then(res => {
                                // 出仓管理列表
                                this.getPriceList();
                                this.$message.success("编辑成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("编辑失败！");
                            });
                    }
                } else {
                    return false;
                }
            });
        },
        // 出仓管理列表 
        getPriceList() {
            reqPriceList({
                searchStr: this.search,
                pageSize,
                pageNum: this.page
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        add() {
            this.isShow = true;
            this.isAdd = true
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
            this.isAdd = false
        },
        del(row) {
            reqDelPrice(row.id)
                .then(res => {
                    console.log(res);
                    // 出仓管理列表
                    this.getPriceList();
                    this.$message.success("删除成功！");
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        pageChange(p) {
            console.log(p);
            this.page = p;
            // 出仓管理列表
            this.getPriceList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>